using System;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Windows.Forms;

namespace ExternalRecorder
{
	/// <summary>
	/// Summary description for RecorderConfig.
	/// </summary>
	public class RecorderConfig : System.Windows.Forms.Form
	{

		#region Form Variables
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Button buttonCancel;
		private Button buttonOK;
		private Button buttonBrowse;
		private TextBox textBoxExecutable;
		private CheckBox checkBoxZeroPad;
		private CheckBox checkBoxThreeDigit;
		private System.Windows.Forms.Label labelExecutable;
		private System.Windows.Forms.TextBox textBoxRecordingParameters;
		private System.Windows.Forms.Label labelInstructions;
		private System.Windows.Forms.TextBox textBoxPreviewParameters;
		private System.Windows.Forms.Label labelPreviewParameters;
		private System.Windows.Forms.Label labelRecordingParameters;
		#endregion

		#region Constructor / Destructor
		public RecorderConfig(int captureSourceOID)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			captureSource = ExternalRecorderConfig.getConfigFromMemory(captureSourceOID);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(RecorderConfig));
			this.buttonCancel = new System.Windows.Forms.Button();
			this.buttonOK = new System.Windows.Forms.Button();
			this.buttonBrowse = new System.Windows.Forms.Button();
			this.textBoxExecutable = new System.Windows.Forms.TextBox();
			this.labelExecutable = new System.Windows.Forms.Label();
			this.checkBoxThreeDigit = new System.Windows.Forms.CheckBox();
			this.textBoxRecordingParameters = new System.Windows.Forms.TextBox();
			this.labelInstructions = new System.Windows.Forms.Label();
			this.checkBoxZeroPad = new System.Windows.Forms.CheckBox();
			this.textBoxPreviewParameters = new System.Windows.Forms.TextBox();
			this.labelPreviewParameters = new System.Windows.Forms.Label();
			this.labelRecordingParameters = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// buttonCancel
			// 
			this.buttonCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonCancel.Location = new System.Drawing.Point(304, 288);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.TabIndex = 6;
			this.buttonCancel.Text = "Cancel";
			// 
			// buttonOK
			// 
			this.buttonOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonOK.Location = new System.Drawing.Point(224, 288);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.TabIndex = 5;
			this.buttonOK.Text = "Ok";
			this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
			// 
			// buttonBrowse
			// 
			this.buttonBrowse.Location = new System.Drawing.Point(472, 13);
			this.buttonBrowse.Name = "buttonBrowse";
			this.buttonBrowse.TabIndex = 1;
			this.buttonBrowse.Text = "Browse";
			this.buttonBrowse.Click += new System.EventHandler(this.buttonBrowse_Click);
			// 
			// textBoxExecutable
			// 
			this.textBoxExecutable.Location = new System.Drawing.Point(128, 14);
			this.textBoxExecutable.Name = "textBoxExecutable";
			this.textBoxExecutable.ReadOnly = true;
			this.textBoxExecutable.Size = new System.Drawing.Size(336, 20);
			this.textBoxExecutable.TabIndex = 0;
			this.textBoxExecutable.Text = "";
			// 
			// labelExecutable
			// 
			this.labelExecutable.Location = new System.Drawing.Point(8, 16);
			this.labelExecutable.Name = "labelExecutable";
			this.labelExecutable.Size = new System.Drawing.Size(72, 16);
			this.labelExecutable.TabIndex = 10;
			this.labelExecutable.Text = "Executable:";
			// 
			// checkBoxThreeDigit
			// 
			this.checkBoxThreeDigit.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.checkBoxThreeDigit.Location = new System.Drawing.Point(128, 248);
			this.checkBoxThreeDigit.Name = "checkBoxThreeDigit";
			this.checkBoxThreeDigit.Size = new System.Drawing.Size(344, 24);
			this.checkBoxThreeDigit.TabIndex = 4;
			this.checkBoxThreeDigit.Text = "Use three digit channel numbers (ignored if not zero padded)";
			// 
			// textBoxRecordingParameters
			// 
			this.textBoxRecordingParameters.Location = new System.Drawing.Point(128, 46);
			this.textBoxRecordingParameters.Name = "textBoxRecordingParameters";
			this.textBoxRecordingParameters.Size = new System.Drawing.Size(336, 20);
			this.textBoxRecordingParameters.TabIndex = 2;
			this.textBoxRecordingParameters.Text = "";
			// 
			// labelInstructions
			// 
			this.labelInstructions.Location = new System.Drawing.Point(128, 104);
			this.labelInstructions.Name = "labelInstructions";
			this.labelInstructions.Size = new System.Drawing.Size(360, 120);
			this.labelInstructions.TabIndex = 18;
			this.labelInstructions.Text = @"Note: The parameters should include the text {channel}. This will be replaced with required channel number. If this text is not supplied, the channel number will be appended.
The recording parameters should include the text {filename}.  This will be replaced with the name of the file that the external program is required to record to.
The recording paramters can also include the text {minutes}.  This will be replace with the length of the recording that has been requested";
			// 
			// checkBoxZeroPad
			// 
			this.checkBoxZeroPad.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.checkBoxZeroPad.Location = new System.Drawing.Point(128, 224);
			this.checkBoxZeroPad.Name = "checkBoxZeroPad";
			this.checkBoxZeroPad.Size = new System.Drawing.Size(272, 24);
			this.checkBoxZeroPad.TabIndex = 3;
			this.checkBoxZeroPad.Text = "Zero pad channel numbers (ie 3 will be 03)";
			// 
			// textBoxPreviewParameters
			// 
			this.textBoxPreviewParameters.Location = new System.Drawing.Point(128, 72);
			this.textBoxPreviewParameters.Name = "textBoxPreviewParameters";
			this.textBoxPreviewParameters.Size = new System.Drawing.Size(336, 20);
			this.textBoxPreviewParameters.TabIndex = 2;
			this.textBoxPreviewParameters.Text = "";
			// 
			// labelPreviewParameters
			// 
			this.labelPreviewParameters.Location = new System.Drawing.Point(8, 76);
			this.labelPreviewParameters.Name = "labelPreviewParameters";
			this.labelPreviewParameters.Size = new System.Drawing.Size(128, 16);
			this.labelPreviewParameters.TabIndex = 16;
			this.labelPreviewParameters.Text = "Preview Parameters:";
			// 
			// labelRecordingParameters
			// 
			this.labelRecordingParameters.Location = new System.Drawing.Point(8, 48);
			this.labelRecordingParameters.Name = "labelRecordingParameters";
			this.labelRecordingParameters.Size = new System.Drawing.Size(128, 16);
			this.labelRecordingParameters.TabIndex = 16;
			this.labelRecordingParameters.Text = "Recording Parameters:";
			// 
			// RecorderConfig
			// 
			this.AcceptButton = this.buttonOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.buttonCancel;
			this.ClientSize = new System.Drawing.Size(560, 318);
			this.Controls.Add(this.checkBoxZeroPad);
			this.Controls.Add(this.textBoxRecordingParameters);
			this.Controls.Add(this.textBoxExecutable);
			this.Controls.Add(this.textBoxPreviewParameters);
			this.Controls.Add(this.checkBoxThreeDigit);
			this.Controls.Add(this.buttonCancel);
			this.Controls.Add(this.buttonOK);
			this.Controls.Add(this.buttonBrowse);
			this.Controls.Add(this.labelExecutable);
			this.Controls.Add(this.labelPreviewParameters);
			this.Controls.Add(this.labelRecordingParameters);
			this.Controls.Add(this.labelInstructions);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "RecorderConfig";
			this.ShowInTaskbar = false;
			this.Text = "External Recorder Configuration";
			this.Load += new System.EventHandler(this.RecorderConfig_Load);
			this.ResumeLayout(false);

		}
		#endregion

		#region Private Variables
		private ExternalRecorderConfig captureSource;
		#endregion

		#region Loading
		private void RecorderConfig_Load(object sender, System.EventArgs e)
		{
			if (((Environment.OSVersion.Version.Major > 4) & (Environment.OSVersion.Version.Minor > 0)) & File.Exists(Application.ExecutablePath + ".manifest"))
			{
				for (int i = 0; i < Controls.Count; i++)
				{
					if (Controls[i].GetType().BaseType == typeof(ButtonBase))
					{
						((ButtonBase)Controls[i]).FlatStyle = FlatStyle.System;
					}
				}
			}

			if (captureSource == null) 
			{
				MessageBox.Show("Please save the capture source first, then you can configure it's settings");
				this.DialogResult = DialogResult.OK;
				this.Close();
				return;
			}
			
			textBoxExecutable.Text = captureSource.executable;
			textBoxRecordingParameters.Text = captureSource.recordingParameters;
			textBoxPreviewParameters.Text = captureSource.previewParameters;

			checkBoxThreeDigit.Checked = captureSource.threeDigit;
			checkBoxZeroPad.Checked = captureSource.zeroPad;
			
		}

		#endregion

		#region Unloading
		private void buttonOK_Click(object sender, System.EventArgs e)
		{
			captureSource.executable = textBoxExecutable.Text;
			captureSource.recordingParameters = textBoxRecordingParameters.Text;
			captureSource.previewParameters = textBoxPreviewParameters.Text;

			captureSource.threeDigit = checkBoxThreeDigit.Checked;
			captureSource.zeroPad = checkBoxZeroPad.Checked;
		}

		#endregion

		#region Browse For Executable
		private void buttonBrowse_Click(object sender, System.EventArgs e)
		{
			FileDialog dialog1 = new OpenFileDialog();
			dialog1.FileName = this.textBoxExecutable.Text;
			dialog1.Filter = "External Recorder Executable (*.exe)|*.exe";
			if (dialog1.ShowDialog() == DialogResult.OK)
			{
				this.textBoxExecutable.Text = dialog1.FileName;
			}
		}
		#endregion

	}
}
